LLVM::DIBuilder - Crystal 1.21.0

# struct LLVM::DIBuilder

- LLVM::DIBuilder
- Struct
- Value
- Object

##
Overview

EXPERIMENTAL The C API wrapped by this type is marked as experimental by LLVM.

##
Defined in:

llvm/di_builder.cr

##
Constructors

- .new(mod : LLVM::Module)

##
Instance Method Summary

- #context
- #create_array_type(size_in_bits, align_in_bits, type, subs : LibLLVM::MetadataRef)

  DEPRECATED Pass an array for `subs` directly

- #create_array_type(size_in_bits, align_in_bits, type, subs)
- #create_auto_variable(scope, name, file, line, type, align_in_bits, flags = DIFlags::Zero)
- #create_basic_type(name, size_in_bits, align_in_bits, encoding)
- #create_compile_unit(lang : DwarfSourceLanguage, file, dir, producer, optimized, flags, runtime_version)
- #create_compile_unit(lang cpp_lang_code, file, dir, producer, optimized, flags, runtime_version)

  DEPRECATED Pass an `LLVM::DwarfSourceLanguage` for `lang` instead

- #create_debug_location(line, column, scope, inlined_at = nil)
- #create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements : LibLLVM::MetadataRef, underlying_type)

  DEPRECATED Pass an array for `elements` directly

- #create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)
- #create_enumerator(name, value)
- #create_expression(addr, length)
- #create_file(file, dir)
- #create_function(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)
- #create_global_variable_expression(scope, name, linkage_name, file, line, type, local_to_unit, expr = nil, decl = nil, align_in_bits = 0_u32)
- #create_lexical_block(scope, file_scope, line, column)
- #create_lexical_block_file(scope, file_scope, discriminator = 0)
- #create_member_type(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)
- #create_parameter_variable(scope, name, argno, file, line, type, flags = DIFlags::Zero)
- #create_pointer_type(pointee, size_in_bits, align_in_bits, name)
- #create_replaceable_composite_type(scope, name, file, line)
- #create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types : LibLLVM::MetadataRef)

  DEPRECATED Pass an array for `element_types` directly

- #create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)
- #create_subroutine_type(file, parameter_types : LibLLVM::MetadataRef)

  DEPRECATED Pass an array for `parameter_types` directly

- #create_subroutine_type(file, parameter_types)
- #create_union_type(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types : LibLLVM::MetadataRef)

  DEPRECATED Pass an array for `element_types` directly

- #create_union_type(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types)
- #create_unspecified_type(name : String)
- #dispose
- #end
- #get_or_create_array(elements : Array(LibLLVM::MetadataRef))
- #get_or_create_array_subrange(lo, count)
- #get_or_create_type_array(types : Array(LibLLVM::MetadataRef))
- #insert_declare_at_end(storage, var_info, expr, dl : LibLLVM::MetadataRef, block)
- #insert_declare_at_end(storage, var_info, expr, dl : LibLLVM::ValueRef | LLVM::Value, block)

  DEPRECATED Use a `LibLLVM::MetadataRef` for `dl` instead

- #replace_temporary(from, to)
- #to_unsafe : LibLLVM::DIBuilderRef

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(mod : LLVM::Module) #

##
Instance Method Detail

def context #
def create_array_type(size_in_bits, align_in_bits, type, subs : LibLLVM::MetadataRef) #

DEPRECATED Pass an array for `subs` directly

def create_array_type(size_in_bits, align_in_bits, type, subs) #
def create_auto_variable(scope, name, file, line, type, align_in_bits, flags = DIFlags::Zero) #
def create_basic_type(name, size_in_bits, align_in_bits, encoding) #
def create_compile_unit(lang : DwarfSourceLanguage, file, dir, producer, optimized, flags, runtime_version) #
def create_compile_unit(lang cpp_lang_code, file, dir, producer, optimized, flags, runtime_version) #

DEPRECATED Pass an `LLVM::DwarfSourceLanguage` for `lang` instead

def create_debug_location(line, column, scope, inlined_at = nil) #
def create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements : LibLLVM::MetadataRef, underlying_type) #

DEPRECATED Pass an array for `elements` directly

def create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type) #
def create_enumerator(name, value) #
def create_expression(addr, length) #
def create_file(file, dir) #
def create_function(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func) #
def create_global_variable_expression(scope, name, linkage_name, file, line, type, local_to_unit, expr = nil, decl = nil, align_in_bits = 0_u32) #
def create_lexical_block(scope, file_scope, line, column) #
def create_lexical_block_file(scope, file_scope, discriminator = 0) #
def create_member_type(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty) #
def create_parameter_variable(scope, name, argno, file, line, type, flags = DIFlags::Zero) #
def create_pointer_type(pointee, size_in_bits, align_in_bits, name) #
def create_replaceable_composite_type(scope, name, file, line) #
def create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types : LibLLVM::MetadataRef) #

DEPRECATED Pass an array for `element_types` directly

def create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types) #
def create_subroutine_type(file, parameter_types : LibLLVM::MetadataRef) #

DEPRECATED Pass an array for `parameter_types` directly

def create_subroutine_type(file, parameter_types) #
def create_union_type(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types : LibLLVM::MetadataRef) #

DEPRECATED Pass an array for `element_types` directly

def create_union_type(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types) #
def create_unspecified_type(name : String) #
def dispose #
def end #
def get_or_create_array(elements : Array(LibLLVM::MetadataRef)) #
def get_or_create_array_subrange(lo, count) #
def get_or_create_type_array(types : Array(LibLLVM::MetadataRef)) #
def insert_declare_at_end(storage, var_info, expr, dl : LibLLVM::MetadataRef, block) #
def insert_declare_at_end(storage, var_info, expr, dl : LibLLVM::ValueRef | LLVM::Value, block) #

DEPRECATED Use a `LibLLVM::MetadataRef` for `dl` instead

def replace_temporary(from, to) #
def to_unsafe : LibLLVM::DIBuilderRef #